using CommonSocketLibrary.Abstract;
using CommonSocketLibrary.Common;
using Serilog;
using TwitchChatTTS.Seven.Socket.Data;

namespace TwitchChatTTS.Seven.Socket.Handlers
{
    public class ErrorHandler : IWebSocketHandler
    {
        private readonly ILogger _logger;
        public int OperationCode { get; } = 6;

        public ErrorHandler(ILogger logger)
        {
            _logger = logger;
        }

        public Task Execute<Data>(SocketClient<WebSocketMessage> sender, Data data)
        {
            if (data is not ErrorMessage message || message == null || message.Exception == null && message.Message == null)
                return Task.CompletedTask;

            if (message.Exception != null)
                _logger.Error(message.Exception, message.Message ?? string.Empty);
            else
                _logger.Error(message.Message!);
            return Task.CompletedTask;
        }
    }
}