using System.Text.Json.Serialization;

namespace TwitchChatTTS.Veadotube
{
    public class VeadoPayloadMessage
    {
        public required string Event { get; set; }
        public required string Type { get; set; }
        public required string Id { get; set; }
        public string? Name { get; set; }
        public required object Payload { get; set; }
    }

    public class VeadoEventMessage
    {
        [JsonPropertyName("event")]
        public required string Event { get; set; }
    }

    public class VeadoNodeState {
        public required string Id { get; set; }
        public required string Name { get; set; }
    }

    public class VeadoNodeStateListMessage : VeadoEventMessage {
        public required IEnumerable<VeadoNodeState> States { get; set; }
    }

    public class VeadoNodeStateMessage : VeadoEventMessage {
        public required string State { get; set; }
    }

    public class VeadoNodeThumbMessage {
        public int Width { get; set; }
        public int Height { get; set; }
        public required string Png { get; set; }
    }
}